/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sax;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author bar
 */
public class SAXSample extends DefaultHandler {

    int nodeCount = 0;


    @Override
    public void startDocument() throws SAXException {
        nodeCount++;
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        nodeCount++;
        for(int i = 0 ; i < atts.getLength() ; i++ ){
            nodeCount++;
        }
    }


    public int getNodeCount(){
        return nodeCount;
    }
    
    public static void main(String[] args){
        try {
            SAXSample saxSample = new SAXSample();
            SAXParserFactory spf = SAXParserFactory.newInstance();
            SAXParser sp = spf.newSAXParser();
            sp.parse(new File(args[0]), saxSample);
            System.out.println("Pocet uzlu v dokument " + args[0] +": " +saxSample.getNodeCount());
        } catch (IOException ex) {
            Logger.getLogger(SAXSample.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(SAXSample.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(SAXSample.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
